Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceConst.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceConst.cs	(revision 8477)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceConst.cs	(revision 8477)
@@ -0,0 +1,79 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableClass]
+  [Item(Name = "CovarianceConst",
+    Description = "Constant covariance function for Gaussian processes.")]
+  public class CovarianceConst : Item, ICovarianceFunction {
+    [Storable]
+    private double sf2;
+    public double Scale { get { return sf2; } }
+
+    [StorableConstructor]
+    protected CovarianceConst(bool deserializing)
+      : base(deserializing) {
+    }
+
+    protected CovarianceConst(CovarianceConst original, Cloner cloner)
+      : base(original, cloner) {
+      this.sf2 = original.sf2;
+    }
+
+    public CovarianceConst()
+      : base() {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new CovarianceConst(this, cloner);
+    }
+
+    public int GetNumberOfParameters(int numberOfVariables) {
+      return 1;
+    }
+
+    public void SetParameter(double[] hyp) {
+      this.sf2 = Math.Exp(2 * hyp[0]);
+    }
+    public void SetData(double[,] x) {
+      // nothing to do
+    }
+
+
+    public void SetData(double[,] x, double[,] xt) {
+      // nothing to do
+    }
+
+    public double GetCovariance(int i, int j) {
+      return sf2;
+    }
+
+    public double GetGradient(int i, int j, int k) {
+      if (k != 0) throw new ArgumentException("CovarianceConst has only one hyperparameters", "k");
+      return 2 * sf2;
+    }
+  }
+}
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceLinear.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceLinear.cs	(revision 8476)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceLinear.cs	(revision 8477)
@@ -29,6 +29,4 @@
   [Item(Name = "CovarianceLinear", Description = "Linear covariance function for Gaussian processes.")]
   public class CovarianceLinear : Item, ICovarianceFunction {
-    private static readonly double[] emptyArray = new double[0];
-
     [Storable]
     private double[,] x;
@@ -89,6 +87,6 @@
     }
 
-    public double[] GetGradient(int i, int j) {
-      return emptyArray;
+    public double GetGradient(int i, int j, int k) {
+      throw new NotSupportedException("CovarianceLinear does not have hyperparameters.");
     }
 
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceNoise.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceNoise.cs	(revision 8477)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceNoise.cs	(revision 8477)
@@ -0,0 +1,83 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableClass]
+  [Item(Name = "CovarianceNoise",
+    Description = "Noise covariance function for Gaussian processes.")]
+  public class CovarianceNoise : Item, ICovarianceFunction {
+    [Storable]
+    private double sf2;
+    public double Scale { get { return sf2; } }
+
+    [StorableConstructor]
+    protected CovarianceNoise(bool deserializing)
+      : base(deserializing) {
+    }
+
+    protected CovarianceNoise(CovarianceNoise original, Cloner cloner)
+      : base(original, cloner) {
+      this.sf2 = original.sf2;
+    }
+
+    public CovarianceNoise()
+      : base() {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new CovarianceNoise(this, cloner);
+    }
+
+    public int GetNumberOfParameters(int numberOfVariables) {
+      return 1;
+    }
+
+    public void SetParameter(double[] hyp) {
+      this.sf2 = Math.Exp(2 * hyp[0]);
+    }
+    public void SetData(double[,] x) {
+      // nothing to do
+    }
+
+
+    public void SetData(double[,] x, double[,] xt) {
+      // nothing to do
+    }
+
+    public double GetCovariance(int i, int j) {
+      if (i == j) return sf2;
+      else return 0.0;
+    }
+
+    public double GetGradient(int i, int j, int k) {
+      if (k != 0) throw new ArgumentException("CovarianceConst has only one hyperparameters", "k");
+      if (i == j)
+        return 2 * sf2;
+      else
+        return 0.0;
+    }
+  }
+}
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovariancePeriodic.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovariancePeriodic.cs	(revision 8476)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovariancePeriodic.cs	(revision 8477)
@@ -35,8 +35,11 @@
     [Storable]
     private double sf2;
+    public double Scale { get { return sf2; } }
     [Storable]
     private double l;
+    public double Length { get { return l; } }
     [Storable]
     private double p;
+    public double Period { get { return p; } }
 
     private bool symmetric;
@@ -74,6 +77,5 @@
       this.p = Math.Exp(hyp[1]);
       this.sf2 = Math.Exp(2 * hyp[2]);
-
-      sf2 = Math.Min(10E6, sf2); // upper limit for the scale
+      // sf2 = Math.Min(10E6, sf2); // upper limit for the scale
 
       sd = null;
@@ -102,40 +104,26 @@
     }
 
+    public double GetGradient(int i, int j, int k) {
+      double v = Math.PI * sd[i, j] / p;
+      switch (k) {
+        case 0: {
+            double newK = Math.Sin(v) / l;
+            newK = newK * newK;
+            return 4 * sf2 * Math.Exp(-2 * newK) * newK;
+          }
+        case 1: {
+            double r = Math.Sin(v) / l;
+            return 4 * sf2 / l * Math.Exp(-2 * r * r) * r * Math.Cos(v) * v;
+          }
+        case 2: {
+            double newK = Math.Sin(v) / l;
+            newK = newK * newK;
+            return 2 * sf2 * Math.Exp(-2 * newK);
 
-    public double[] GetDiagonalCovariances() {
-      if (x != xt) throw new InvalidOperationException();
-      int rows = x.GetLength(0);
-      var cov = new double[rows];
-      for (int i = 0; i < rows; i++) {
-        double k = Math.Sqrt(Util.SqrDist(Util.GetRow(x, i), Util.GetRow(xt, i)));
-        k = Math.PI * k / p;
-        k = Math.Sin(k) / l;
-        k = k * k;
-        cov[i] = sf2 * Math.Exp(-2.0 * k);
+          }
+        default: {
+            throw new ArgumentException("CovariancePeriodic only has three hyperparameters.", "k");
+          }
       }
-      return cov;
-    }
-
-    public double[] GetGradient(int i, int j) {
-
-      var res = new double[3];
-      double k = sd[i, j];
-      k = Math.PI * k / p;
-      {
-        double newK = Math.Sin(k) / l;
-        newK = newK * newK;
-        res[0] = 4 * sf2 * Math.Exp(-2 * newK) * newK;
-      }
-      {
-        double r = Math.Sin(k) / l;
-        res[1] = 4 * sf2 / l * Math.Exp(-2 * r * r) * r * Math.Cos(k) * k;
-      }
-      {
-        double newK = Math.Sin(k) / l;
-        newK = newK * newK;
-        res[2] = 2 * sf2 * Math.Exp(-2 * newK);
-      }
-
-      return res;
     }
 
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceProd.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceProd.cs	(revision 8476)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceProd.cs	(revision 8477)
@@ -20,4 +20,6 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
 using System.Linq;
 using HeuristicLab.Common;
@@ -48,4 +50,5 @@
       this.factors = cloner.Clone(original.factors);
       this.numberOfVariables = original.numberOfVariables;
+      AttachEventHandlers();
     }
 
@@ -53,4 +56,13 @@
       : base() {
       this.factors = new ItemList<ICovarianceFunction>();
+      AttachEventHandlers();
+    }
+
+    private void AttachEventHandlers() {
+      this.factors.CollectionReset += (sender, args) => ClearCache();
+      this.factors.ItemsAdded += (sender, args) => ClearCache();
+      this.factors.ItemsRemoved += (sender, args) => ClearCache();
+      this.factors.ItemsReplaced += (sender, args) => ClearCache();
+      this.factors.ItemsMoved += (sender, args) => ClearCache();
     }
 
@@ -86,6 +98,35 @@
     }
 
-    public double[] GetGradient(int i, int j) {
-      return factors.Select(t => t.GetGradient(i, j)).SelectMany(seq => seq).ToArray();
+    private Dictionary<int, Tuple<int, int>> cachedParameterMap;
+    public double GetGradient(int i, int j, int k) {
+      if (cachedParameterMap == null) {
+        CalculateParameterMap();
+      }
+      int ti = cachedParameterMap[k].Item1;
+      k = cachedParameterMap[k].Item2;
+      double res = 1.0;
+      for (int ii = 0; ii < factors.Count; ii++) {
+        var f = factors[ii];
+        if (ii == ti) {
+          res *= f.GetGradient(i, j, k);
+        } else {
+          res *= f.GetCovariance(i, j);
+        }
+      }
+      return res;
+    }
+
+    private void ClearCache() {
+      cachedParameterMap = null;
+    }
+
+    private void CalculateParameterMap() {
+      cachedParameterMap = new Dictionary<int, Tuple<int, int>>();
+      int k = 0;
+      for (int ti = 0; ti < factors.Count; ti++) {
+        for (int ti_k = 0; ti_k < factors[ti].GetNumberOfParameters(numberOfVariables); ti_k++) {
+          cachedParameterMap[k++] = Tuple.Create(ti, ti_k);
+        }
+      }
     }
   }
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceRQiso.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceRQiso.cs	(revision 8477)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceRQiso.cs	(revision 8477)
@@ -0,0 +1,145 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableClass]
+  [Item(Name = "CovarianceRQiso",
+    Description = "Isotropic rational quadratic covariance function for Gaussian processes.")]
+  public class CovarianceRQiso : Item, ICovarianceFunction {
+    [Storable]
+    private double[,] x;
+    [Storable]
+    private double[,] xt;
+    [Storable]
+    private double sf2;
+    public double Scale { get { return sf2; } }
+    [Storable]
+    private double l;
+    public double Length { get { return l; } }
+    [Storable]
+    private double alpha;
+    public double Shape { get { return alpha; } }
+    [Storable]
+    private bool symmetric;
+    private double[,] d2;
+
+    [StorableConstructor]
+    protected CovarianceRQiso(bool deserializing)
+      : base(deserializing) {
+    }
+
+    protected CovarianceRQiso(CovarianceRQiso original, Cloner cloner)
+      : base(original, cloner) {
+      if (original.x != null) {
+        this.x = new double[original.x.GetLength(0), original.x.GetLength(1)];
+        Array.Copy(original.x, this.x, x.Length);
+
+        this.xt = new double[original.xt.GetLength(0), original.xt.GetLength(1)];
+        Array.Copy(original.xt, this.xt, xt.Length);
+
+        this.d2 = new double[original.d2.GetLength(0), original.d2.GetLength(1)];
+        Array.Copy(original.d2, this.d2, d2.Length);
+        this.sf2 = original.sf2;
+      }
+      this.sf2 = original.sf2;
+      this.l = original.l;
+      this.alpha = original.alpha;
+      this.symmetric = original.symmetric;
+    }
+
+    public CovarianceRQiso()
+      : base() {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new CovarianceRQiso(this, cloner);
+    }
+
+    public int GetNumberOfParameters(int numberOfVariables) {
+      return 3;
+    }
+
+    public void SetParameter(double[] hyp) {
+      this.l = Math.Exp(hyp[0]);
+      this.sf2 = Math.Exp(2 * hyp[1]);
+      this.alpha = Math.Exp(hyp[2]);
+      d2 = null;
+    }
+    public void SetData(double[,] x) {
+      SetData(x, x);
+      this.symmetric = true;
+    }
+
+
+    public void SetData(double[,] x, double[,] xt) {
+      this.symmetric = false;
+      this.x = x;
+      this.xt = xt;
+      d2 = null;
+    }
+
+    public double GetCovariance(int i, int j) {
+      if (d2 == null) CalculateSquaredDistances();
+      return sf2 * Math.Pow(1 + 0.5 * d2[i, j] / alpha, -alpha);
+    }
+
+    public double GetGradient(int i, int j, int k) {
+      switch (k) {
+        case 0: return sf2 * Math.Pow(1 + 0.5 * d2[i, j] / alpha, -alpha - 1) * d2[i, j];
+        case 1: return 2 * sf2 * Math.Pow((1 + 0.5 * d2[i, j] / alpha), (-alpha));
+        case 2: {
+            double g = (1 + 0.5 * d2[i, j] / alpha);
+            g = sf2 * Math.Pow(g, -alpha) * (0.5 * d2[i, j] / g - alpha * Math.Log(g));
+            return g;
+          }
+        default: throw new ArgumentException("CovarianceRQiso has three hyperparameters", "k");
+      }
+    }
+
+    private void CalculateSquaredDistances() {
+      if (x.GetLength(1) != xt.GetLength(1)) throw new InvalidOperationException();
+      int rows = x.GetLength(0);
+      int cols = xt.GetLength(0);
+      d2 = new double[rows, cols];
+      double lInv = 1.0 / l;
+      if (symmetric) {
+        for (int i = 0; i < rows; i++) {
+          for (int j = i; j < rows; j++) {
+            d2[i, j] = Util.SqrDist(Util.GetRow(x, i).Select(e => e * lInv), Util.GetRow(xt, j).Select(e => e * lInv));
+            d2[j, i] = d2[i, j];
+          }
+        }
+      } else {
+        for (int i = 0; i < rows; i++) {
+          for (int j = 0; j < cols; j++) {
+            d2[i, j] = Util.SqrDist(Util.GetRow(x, i).Select(e => e * lInv), Util.GetRow(xt, j).Select(e => e * lInv));
+          }
+        }
+      }
+    }
+  }
+}
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceSEard.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceSEard.cs	(revision 8476)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceSEard.cs	(revision 8477)
@@ -36,6 +36,16 @@
     [Storable]
     private double sf2;
+    public double Scale { get { return sf2; } }
+
     [Storable]
     private double[] l;
+    public double[] Length {
+      get {
+        if (l == null) return new double[0];
+        var copy = new double[l.Length];
+        Array.Copy(l, copy, copy.Length);
+        return copy;
+      }
+    }
 
     private double[,] sd;
@@ -76,5 +86,5 @@
       this.l = hyp.Take(hyp.Length - 1).Select(Math.Exp).ToArray();
       this.sf2 = Math.Exp(2 * hyp[hyp.Length - 1]);
-      sf2 = Math.Min(10E6, sf2); // upper limit for the scale
+      // sf2 = Math.Min(10E6, sf2); // upper limit for the scale
 
       sd = null;
@@ -99,13 +109,13 @@
     }
 
-    public double[] GetGradient(int i, int j) {
-      var res = new double[l.Length + 1];
-      for (int k = 0; k < l.Length; k++) {
+    public double GetGradient(int i, int j, int k) {
+      if (k < l.Length) {
         double sqrDist = Util.SqrDist(x[i, k] / l[k], xt[j, k] / l[k]);
-
-        res[k] = sf2 * Math.Exp(-sd[i, j] / 2.0) * sqrDist;
+        return sf2 * Math.Exp(-sd[i, j] / 2.0) * sqrDist;
+      } else if (k == l.Length) {
+        return 2.0 * sf2 * Math.Exp(-sd[i, j] / 2.0);
+      } else {
+        throw new ArgumentException("CovarianceSEard has dimension+1 hyperparameters.", "k");
       }
-      res[res.Length - 1] = 2.0 * sf2 * Math.Exp(-sd[i, j] / 2.0);
-      return res;
     }
 
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceSEiso.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceSEiso.cs	(revision 8476)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceSEiso.cs	(revision 8477)
@@ -37,6 +37,8 @@
     [Storable]
     private double sf2;
+    public double Scale { get { return sf2; } }
     [Storable]
     private double l;
+    public double Length { get { return l; } }
     [Storable]
     private bool symmetric;
@@ -80,5 +82,5 @@
     public void SetParameter(double[] hyp) {
       this.l = Math.Exp(hyp[0]);
-      this.sf2 = Math.Min(1E6, Math.Exp(2 * hyp[1])); // upper limit for scale
+      this.sf2 = Math.Exp(2 * hyp[1]);
       sd = null;
     }
@@ -101,9 +103,10 @@
     }
 
-    public double[] GetGradient(int i, int j) {
-      var res = new double[2];
-      res[0] = sf2 * Math.Exp(-sd[i, j] / 2.0) * sd[i, j];
-      res[1] = 2.0 * sf2 * Math.Exp(-sd[i, j] / 2.0);
-      return res;
+    public double GetGradient(int i, int j, int k) {
+      switch (k) {
+        case 0: return sf2 * Math.Exp(-sd[i, j] / 2.0) * sd[i, j];
+        case 1: return 2.0 * sf2 * Math.Exp(-sd[i, j] / 2.0);
+        default: throw new ArgumentException("CovarianceSEiso has two hyperparameters", "k");
+      }
     }
 
@@ -113,8 +116,9 @@
       int cols = xt.GetLength(0);
       sd = new double[rows, cols];
+      double lInv = 1.0 / l;
       if (symmetric) {
         for (int i = 0; i < rows; i++) {
           for (int j = i; j < rows; j++) {
-            sd[i, j] = Util.SqrDist(Util.GetRow(x, i).Select(e => e / l), Util.GetRow(xt, j).Select(e => e / l));
+            sd[i, j] = Util.SqrDist(Util.GetRow(x, i).Select(e => e * lInv), Util.GetRow(xt, j).Select(e => e * lInv));
             sd[j, i] = sd[i, j];
           }
@@ -123,5 +127,5 @@
         for (int i = 0; i < rows; i++) {
           for (int j = 0; j < cols; j++) {
-            sd[i, j] = Util.SqrDist(Util.GetRow(x, i).Select(e => e / l), Util.GetRow(xt, j).Select(e => e / l));
+            sd[i, j] = Util.SqrDist(Util.GetRow(x, i).Select(e => e * lInv), Util.GetRow(xt, j).Select(e => e * lInv));
           }
         }
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceSum.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceSum.cs	(revision 8476)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceSum.cs	(revision 8477)
@@ -20,4 +20,6 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
 using System.Linq;
 using HeuristicLab.Common;
@@ -48,4 +50,5 @@
       this.terms = cloner.Clone(original.terms);
       this.numberOfVariables = original.numberOfVariables;
+      AttachEventHandlers();
     }
 
@@ -53,4 +56,13 @@
       : base() {
       this.terms = new ItemList<ICovarianceFunction>();
+      AttachEventHandlers();
+    }
+
+    private void AttachEventHandlers() {
+      this.terms.CollectionReset += (sender, args) => ClearCache();
+      this.terms.ItemsAdded += (sender, args) => ClearCache();
+      this.terms.ItemsRemoved += (sender, args) => ClearCache();
+      this.terms.ItemsReplaced += (sender, args) => ClearCache();
+      this.terms.ItemsMoved += (sender, args) => ClearCache();
     }
 
@@ -86,6 +98,25 @@
     }
 
-    public double[] GetGradient(int i, int j) {
-      return terms.Select(t => t.GetGradient(i, j)).SelectMany(seq => seq).ToArray();
+    private Dictionary<int, Tuple<int, int>> cachedParameterMap;
+    public double GetGradient(int i, int j, int k) {
+      if (cachedParameterMap == null) {
+        CalculateParameterMap();
+      }
+      int ti = cachedParameterMap[k].Item1;
+      k = cachedParameterMap[k].Item2;
+      return terms[ti].GetGradient(i, j, k);
+    }
+    private void ClearCache() {
+      cachedParameterMap = null;
+    }
+
+    private void CalculateParameterMap() {
+      cachedParameterMap = new Dictionary<int, Tuple<int, int>>();
+      int k = 0;
+      for (int ti = 0; ti < terms.Count; ti++) {
+        for (int ti_k = 0; ti_k < terms[ti].GetNumberOfParameters(numberOfVariables); ti_k++) {
+          cachedParameterMap[k++] = Tuple.Create(ti, ti_k);
+        }
+      }
     }
   }
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessHyperparameterInitializer.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessHyperparameterInitializer.cs	(revision 8476)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessHyperparameterInitializer.cs	(revision 8477)
@@ -38,4 +38,5 @@
     private const string ProblemDataParameterName = "ProblemData";
     private const string HyperparameterParameterName = "Hyperparameter";
+    private const string RandomParameterName = "Random";
 
     #region Parameter Properties
@@ -49,4 +50,7 @@
     public ILookupParameter<IDataAnalysisProblemData> ProblemDataParameter {
       get { return (ILookupParameter<IDataAnalysisProblemData>)Parameters[ProblemDataParameterName]; }
+    }
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters[RandomParameterName]; }
     }
     // out
@@ -71,4 +75,5 @@
       Parameters.Add(new LookupParameter<ICovarianceFunction>(CovarianceFunctionParameterName, "The covariance function for the Gaussian process model."));
       Parameters.Add(new LookupParameter<IDataAnalysisProblemData>(ProblemDataParameterName, "The input data for the Gaussian process."));
+      Parameters.Add(new LookupParameter<IRandom>(RandomParameterName, "The pseudo random number generator to use for initializing the hyperparameter vector."));
       // out
       Parameters.Add(new LookupParameter<RealVector>(HyperparameterParameterName, "The initial hyperparameter vector for the Gaussian process model."));
@@ -83,5 +88,10 @@
       int l = 1 + MeanFunction.GetNumberOfParameters(inputVariablesCount) +
               CovarianceFunction.GetNumberOfParameters(inputVariablesCount);
-      HyperparameterParameter.ActualValue = new RealVector(l);
+      var r = new RealVector(l);
+      var rand = RandomParameter.ActualValue;
+      for (int i = 0; i < r.Length; i++)
+        r[i] = rand.NextDouble() * 2 - 1;
+
+      HyperparameterParameter.ActualValue = r;
       return base.Apply();
     }
